/*********************************************************************
 * S_Socket.H -- simple AF_INET socket class
 * $Id: S_Llist.C,v 1.3 1998/04/10 18:10:31 tjko Exp $
 *
 * Copyright (c) 1998  Timo Kokkonen <tjko@iki.fi>
 *
 *
 * This file may be copied under the terms and conditions 
 * of the GNU General Public License, as published by the Free
 * Software Foundation (Cambridge, Massachusetts).
 */

#include "S_Llist.H"

static char *rcsid = "$Id: S_Llist.C,v 1.3 1998/04/10 18:10:31 tjko Exp $";


S_Llist::S_Llist(int type)
{
  if (rcsid);
  list=0;
  last=0;
  mode=(type?1:0);
  items=0;
}


S_Llist::~S_Llist()
{
  S_Item *d,*i = list;

  if (mode) {
    while (i) {
      d=i;
      i=i->next_;
      delete d;
    }
  }
}


void S_Llist::push_(S_Item *i, S_Item *place, int first)
{
  if (!i) return;

  if (mode) i = i->duplicate();


  if (!list) { // first item
    list=i; 
    last=i;
    items=1;
    i->prev_=NULL; i->next_=NULL;
    return;
  }

  if (first) { // add to the beginning of the list
    i->prev_=NULL;
    i->next_=list;
    list->prev_=i;
    list=i;
    items++;
    return;
  }

  if (!place) place=last;

  if (place==last) {
      i->next_=NULL;
      i->prev_=last;
      last->next_=i;
      last=i;
      items++;
      return;
  }

  i->prev_=place;
  i->next_=place->next_;
  place->next_=i;
  if (i->next_) (i->next_)->prev_=i;
  items++;
}


void S_Llist::pop(S_Item *i)
{

  if (!i) return;

  if (i==list) {
    list=i->next_;
    if (list) list->prev_=NULL;
    else last=NULL;
  } else if (i==last) {
    last=i->prev_;
    if (last) last->next_=NULL;
    else list=NULL;
  } else {
    (i->prev_)->next_=i->next_;
    (i->next_)->prev_=i->prev_;
  }

  if (mode) delete i;
  items--;
}


S_Item *S_Llist::item(unsigned long index)
{
  S_Item *item = list;

  if (index >= items) return NULL;
  if (index == 0) return list;
  if (index == items-1) return last;
  for (unsigned long j=0; j < index; j++) item=item->next_;
  return item;
}
